#!/usr/bin/python
#John Good
#28/10/04
#For use with filenames which contain a date, use to change the structure of
#an unorganised data directory to a yyyy/mm/dd format.  Creates new directory
#structure as needed. 



import os, re, sys


def visit(arg, dirname, names):
  for n in names: # set variable
      result = re.match("^SCI_NL__2P....(\d{8}).*\.N1", n)# match this filename type: SCI_NL__2PODPA20020912_162321_000054492009_00241_02800_0435.N1
      if result:
          date= result.group(1) # use the first group (e.g. the first () to appear above)
          year=date[0:4] # year (e.g. "2002"0912) Remember it doesn't take the last number and you start at 0!
          month=date[4:6] # month (2002"09"12)
          day=date[6:8] # day (200209"12")
          newpath = "%s/%s/%s/%s" % (arg,year,month,day)# set new path
          if not os.path.exists(newpath): os.makedirs(newpath)# make new path
          newfilename =  "%s/%s" % (newpath,n)
          oldfilename =  "%s/%s" % (dirname,n)
          print "%s -> %s" % (oldfilename, newfilename)# tell me about it
          os.rename(oldfilename, newfilename)
      else:
          print "not renamed %s/%s" % (dirname,n)# don't fall over

  raw_input("All done! Press enter to exit.")# graceful exit

startpath = sys.argv[1] # set start point
os.path.walk(startpath,visit,"/disks/calm1/sciamachy/data/l2")# set end point

